<!DOCTYPE html>
<html>

<head>

<meta charset="UTF-8">
<meta name=viewport content="width=device-width, initial-scale=1">


<title>What's Coming in 2015? - Apache Drill</title>

<link href="//maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css" rel="stylesheet" type="text/css"/>
<link href='//fonts.googleapis.com/css?family=PT+Sans' rel='stylesheet' type='text/css'/>
<link href="/css/site.css" rel="stylesheet" type="text/css"/>

<link rel="shortcut icon" href="/favicon.ico" type="image/x-icon"/>
<link rel="icon" href="/favicon.ico" type="image/x-icon"/>

<script src="//ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js" language="javascript" type="text/javascript"></script>
<script src="//cdnjs.cloudflare.com/ajax/libs/jquery-easing/1.3/jquery.easing.min.js" language="javascript" type="text/javascript"></script>
<script language="javascript" type="text/javascript" src="/js/modernizr.custom.js"></script>
<script language="javascript" type="text/javascript" src="/js/script.js"></script>
<script language="javascript" type="text/javascript" src="/js/drill.js"></script>

</head>


<body onResize="resized();">
  <div class="page-wrap">
    <div class="bui"></div>

<div id="menu" class="mw">
<ul>
  <li class='toc-categories'>
  <a class="expand-toc-icon" href="javascript:void(0);"><i class="fa fa-bars"></i></a>
  </li>
  <li class="logo"><a href="/"></a></li>
  <li class='expand-menu'>
  <a href="javascript:void(0);"><span class='menu-text'>Menu</span><span class='expand-icon'><i class="fa fa-bars"></i></span></a>
  </li>
  <li class='clear-float'></li>
  <li class="documentation-menu">
    <a href="/docs/">Documentation</a>
    <ul>
      
        <li><a href="/docs/getting-started/">Getting Started</a></li>
      
        <li><a href="/docs/architecture/">Architecture</a></li>
      
        <li><a href="/docs/tutorials/">Tutorials</a></li>
      
        <li><a href="/docs/install-drill/">Install Drill</a></li>
      
        <li><a href="/docs/configure-drill/">Configure Drill</a></li>
      
        <li><a href="/docs/connect-a-data-source/">Connect a Data Source</a></li>
      
        <li><a href="/docs/odbc-jdbc-interfaces/">ODBC/JDBC Interfaces</a></li>
      
        <li><a href="/docs/query-data/">Query Data</a></li>
      
        <li><a href="/docs/performance-tuning/">Performance Tuning</a></li>
      
        <li><a href="/docs/log-and-debug/">Log and Debug</a></li>
      
        <li><a href="/docs/sql-reference/">SQL Reference</a></li>
      
        <li><a href="/docs/data-sources-and-file-formats/">Data Sources and File Formats</a></li>
      
        <li><a href="/docs/develop-custom-functions/">Develop Custom Functions</a></li>
      
        <li><a href="/docs/troubleshooting/">Troubleshooting</a></li>
      
        <li><a href="/docs/developer-information/">Developer Information</a></li>
      
        <li><a href="/docs/release-notes/">Release Notes</a></li>
      
        <li><a href="/docs/sample-datasets/">Sample Datasets</a></li>
      
        <li><a href="/docs/archived-pages/">Archived Pages</a></li>
      
        <li><a href="/docs/progress-reports/">Progress Reports</a></li>
      
        <li><a href="/docs/project-bylaws/">Project Bylaws</a></li>
      
    </ul>
  </li>
  <li class='nav'>
    <a href="/community-resources/">Community</a>
    <ul>
      <li><a href="/team/">Team</a></li>
      <li><a href="/mailinglists/">Mailing Lists</a></li>
      <li><a href="/community-resources/">Community Resources</a></li>
    </ul>
  </li>
  <li class='nav'><a href="/faq/">FAQ</a></li>
  <li class='nav'><a href="/blog/">Blog</a></li>
  <li id="twitter-menu-item"><a href="https://twitter.com/apachedrill" title="apachedrill on twitter" target="_blank"><img src="/images/twitter_32_26_white.png" alt="twitter logo" align="center"></a> </li>
  <li class='search-bar'>
    <form id="drill-search-form">
      <input type="text" placeholder="Search Apache Drill" id="drill-search-term" />
      <button type="submit">
        <i class="fa fa-search"></i>
      </button>
    </form>
  </li>
  <li class="d">
    <a href="/download/">
      <i class="fa fa-cloud-download"></i> Download
    </a>
  </li>
</ul>
</div>

    <link href="/css/content.css" rel="stylesheet" type="text/css">

<div class="post int_text">
  <header class="post-header">
    <div class="int_title">
      <h1 class="post-title">What's Coming in 2015?</h1>
    </div>
    <p class="post-meta">
    
      
      
      <strong>Author:</strong> Tomer Shiran (Founder, PMC Member and Committer, Apache Drill)<br />
    
<strong>Date:</strong> Dec 16, 2014
</p>
  </header>
  <div class="addthis_sharing_toolbox"></div>

  <article class="post-content">
    <p>2014 was an exciting year for the Drill community. In August we made Drill available for downloads, and last week the Apache Software Foundation promoted Drill to a top-level project. Many of you have asked me what&#39;s coming next, so I decided to sit down and outline some of the interesting initiatives that the Drill community is currently working on:</p>

<ul>
<li>Flexible Access Control</li>
<li>JSON in Any Shape or Form</li>
<li>Advanced SQL</li>
<li>New Data Sources</li>
<li>Drill/Spark Integration</li>
<li>Operational Enhancements: Speed, Scalability and Workload Management</li>
</ul>

<p>This is by no means intended to be an exhaustive list of everything that will be added to Drill in 2015. With Drill&#39;s rapidly expanding community, I anticipate that you&#39;ll see a whole lot more.</p>

<h2 id="flexible-access-control">Flexible Access Control</h2>

<p>Many organizations are now interested in providing Drill as a service to their users, supporting many users, groups and organizations with a single cluster. To do so, they need to be able to control who can access what data. Today&#39;s volume and variety of data requires a new approach to access control. For example, it is becoming impractical for organizations to manage a standalone, centralized repository of permissions for every column/row of every table. Drill&#39;s virtual datasets (views) provide a more scalable solution to access control:</p>

<ul>
<li>The user creates a virtual dataset (<code>CREATE VIEW vd AS SELECT ...</code>), selecting the data to be exposed/shared. The virtual dataset is defined as a SQL statement. For example, a virtual dataset may represent only the records that were created in the last 30 days and don&#39;t have the <code>restricted</code> flag. It could even mask some columns. Drill&#39;s virtual datasets (just the SQL statement) are stored as files in the file system, so users can leverage file system permissions to control who can access the virtual dataset, without granting access to the source data.</li>
<li>A virtual dataset is owned by a specific user and can only &quot;select&quot; data that the owner has access to. The data sources (HDFS, HBase, MongoDB, etc.) are responsible for access control decisions. Users and administrators do not need to define separate permissions inside Drill or utilize yet another centralized permission repository, such as Sentry and Ranger.</li>
</ul>

<h2 id="json-in-any-shape-or-form">JSON in Any Shape or Form</h2>

<p>When data is <strong>Big</strong> (as in Big Data), it is painful to copy and transform it. Users should be able to explore the raw data without (or at least prior to) transforming it into another format. Drill is designed to enable in-situ analytics. Just point it at a file or directory and run the queries.</p>

<p>JSON has emerged as the most common self-describing format, and Drill is able to query JSON files out of the box. Drill currently assumes that the JSON documents (or records) are stored sequentially in a file:</p>
<div class="highlight"><pre><code class="language-json" data-lang="json"><span class="p">{</span> <span class="nt">&quot;name&quot;</span><span class="p">:</span> <span class="s2">&quot;Lee&quot;</span><span class="p">,</span> <span class="nt">&quot;yelping_since&quot;</span><span class="p">:</span> <span class="s2">&quot;2012-02&quot;</span> <span class="p">}</span>
<span class="p">{</span> <span class="nt">&quot;name&quot;</span><span class="p">:</span> <span class="s2">&quot;Matthew&quot;</span><span class="p">,</span> <span class="nt">&quot;yelping_since&quot;</span><span class="p">:</span> <span class="s2">&quot;2011-12&quot;</span> <span class="p">}</span>
<span class="p">{</span> <span class="nt">&quot;name&quot;</span><span class="p">:</span> <span class="s2">&quot;Jasmine&quot;</span><span class="p">,</span> <span class="nt">&quot;yelping_since&quot;</span><span class="p">:</span> <span class="s2">&quot;2010-09&quot;</span> <span class="p">}</span>
</code></pre></div>
<p>However, many JSON-based datasets, ranging from <a href="http://data.gov">data.gov</a> (government) datasets to Twitter API responses, are not organized as simple sequences of JSON documents. In some cases the actual records are listed as elements of an internal array inside a single JSON document. For example, consider the following file, which technically consists of a single JSON document, but really contains three records (under the <code>data.records</code> field):</p>
<div class="highlight"><pre><code class="language-json" data-lang="json"><span class="p">{</span>
  <span class="nt">&quot;metadata&quot;</span><span class="p">:</span> <span class="err">...</span><span class="p">,</span>
  <span class="nt">&quot;data&quot;</span><span class="p">:</span> <span class="p">{</span>
    <span class="nt">&quot;records&quot;</span><span class="p">:</span> <span class="p">[</span>
      <span class="p">{</span> <span class="nt">&quot;name&quot;</span><span class="p">:</span> <span class="s2">&quot;Lee&quot;</span><span class="p">,</span> <span class="nt">&quot;yelping_since&quot;</span><span class="p">:</span> <span class="s2">&quot;2012-02&quot;</span> <span class="p">},</span>
      <span class="p">{</span> <span class="nt">&quot;name&quot;</span><span class="p">:</span> <span class="s2">&quot;Matthew&quot;</span><span class="p">,</span> <span class="nt">&quot;yelping_since&quot;</span><span class="p">:</span> <span class="s2">&quot;2011-12&quot;</span> <span class="p">},</span>
      <span class="p">{</span> <span class="nt">&quot;name&quot;</span><span class="p">:</span> <span class="s2">&quot;Jasmine&quot;</span><span class="p">,</span> <span class="nt">&quot;yelping_since&quot;</span><span class="p">:</span> <span class="s2">&quot;2010-09&quot;</span> <span class="p">}</span>
    <span class="p">]</span>
  <span class="p">}</span>
<span class="p">}</span>
</code></pre></div>
<p>The <code>FLATTEN</code> function in Drill 0.7+ takes an array and converts each item into a top-level record:</p>
<div class="highlight"><pre><code class="language-sql" data-lang="sql"><span class="k">SELECT</span> <span class="n">FLATTEN</span><span class="p">(</span><span class="k">data</span><span class="p">.</span><span class="n">records</span><span class="p">)</span> <span class="k">FROM</span> <span class="n">dfs</span><span class="p">.</span><span class="n">tmp</span><span class="p">.</span><span class="o">`</span><span class="n">foo</span><span class="p">.</span><span class="n">json</span><span class="o">`</span><span class="p">;</span>
</code></pre></div>
<p>You can use this as an inner query (or inside a view):</p>
<div class="highlight"><pre><code class="language-sql" data-lang="sql"><span class="o">&gt;</span> <span class="k">SELECT</span> <span class="n">t</span><span class="p">.</span><span class="n">record</span><span class="p">.</span><span class="n">name</span> <span class="k">AS</span> <span class="n">name</span>
  <span class="k">FROM</span> <span class="p">(</span><span class="k">SELECT</span> <span class="n">FLATTEN</span><span class="p">(</span><span class="k">data</span><span class="p">.</span><span class="n">records</span><span class="p">)</span> <span class="k">AS</span> <span class="n">record</span> <span class="k">FROM</span> <span class="n">dfs</span><span class="p">.</span><span class="n">tmp</span><span class="p">.</span><span class="o">`</span><span class="n">test</span><span class="o">/</span><span class="n">foo</span><span class="p">.</span><span class="n">json</span><span class="o">`</span><span class="p">)</span> <span class="n">t</span><span class="p">;</span>
<span class="o">+</span><span class="c1">------------+</span>
<span class="o">|</span>    <span class="n">name</span>    <span class="o">|</span>
<span class="o">+</span><span class="c1">------------+</span>
<span class="o">|</span> <span class="n">Lee</span>        <span class="o">|</span>
<span class="o">|</span> <span class="n">Matthew</span>    <span class="o">|</span>
<span class="o">|</span> <span class="n">Jasmine</span>    <span class="o">|</span>
<span class="o">+</span><span class="c1">------------+</span>
</code></pre></div>
<p>While this works today, the dataset is technically a single JSON document, so Drill ends up reading the entire dataset into memory. We&#39;re developing a FLATTEN-pushdown mechanism that will enable the JSON reader to emit the individual records into the downstream operators, thereby making this work with datasets of arbitrary size. Once that&#39;s implemented, users will be able to explore any JSON-based dataset in-situ (ie, without having to transform it).</p>

<h2 id="full-sql">Full SQL</h2>

<p>Unlike the majority of SQL engines for Hadoop and NoSQL databases, which support SQL-like languages (HiveQL, CQL, etc.), Drill is designed from the ground up to be compliant with ANSI SQL. We simply started with a real SQL parser (Apache Calcite, previously known as Optiq). We&#39;re currently implementing the remaining SQL constructs, and plan to support the full TPC-DS suite (with no query modifications) in 2015. Full SQL support makes BI tools work better, and enables users who are proficient with SQL to leverage their existing knowledge and skills.</p>

<h2 id="new-data-sources">New Data Sources</h2>

<p>Drill is a standalone, distributed SQL engine. It has a pluggable architecture that allows it to support multiple data sources. Drill 0.6 includes storage plugins for:</p>

<ul>
<li><a href="https://hadoop.apache.org/docs/current/api/org/apache/hadoop/fs/FileSystem.html">Hadoop File System</a> implementations (local file system, HDFS, MapR-FS, Amazon S3, etc.)</li>
<li>HBase and MapR-DB</li>
<li>MongoDB</li>
<li>Hive Metastore (query any dataset that is registered in Hive Metastore)</li>
</ul>

<p>A single query can join data from different systems. For example, a query can join user profiles in MongoDB with log files in Hadoop, or datasets in multiple Hadoop clusters.</p>

<p>I&#39;m eager to see what storage plugins the community develops over the next 12 months. In the last few weeks alone, developers in the community have expressed their desire (on the <a href="mailto:dev@drill.apache.org">public list</a>) to develop additional storage plugins for the following data sources:</p>

<ul>
<li>Cassandra</li>
<li>Solr</li>
<li>JDBC (any RDBMS, including Oracle, MySQL, PostgreSQL and SQL Server)</li>
</ul>

<p>If you&#39;re interested in implementing a new storage plugin, I would encourage you to reach out to the Drill developer community on <a href="mailto:dev@drill.apache.org">dev@drill.apache.org</a>. I&#39;m looking forward to publishing an example of a single-query join across 10 data sources.</p>

<h2 id="drill/spark-integration">Drill/Spark Integration</h2>

<p>We&#39;re seeing growing interest in Spark as an execution engine for data pipelines, providing an alternative to MapReduce. The Drill community is working on integrating Drill and Spark to address a few new use cases:</p>

<ul>
<li><p>Use a Drill query (or view) as the input to Spark. Drill is a powerful engine for extracting and pre-processing data from various data sources, thereby reducing development time and effort. Here&#39;s an example:</p>
<div class="highlight"><pre><code class="language-scala" data-lang="scala"><span class="k">val</span> <span class="n">sc</span> <span class="k">=</span> <span class="k">new</span> <span class="nc">SparkContext</span><span class="o">(</span><span class="n">conf</span><span class="o">)</span>
<span class="k">val</span> <span class="n">result</span> <span class="k">=</span> <span class="n">sc</span><span class="o">.</span><span class="n">drillRDD</span><span class="o">(</span><span class="s">&quot;SELECT * FROM dfs.root.`path/to/logs` l, mongo.mydb.users u WHERE l.user_id = u.id GROUP BY ...&quot;</span><span class="o">)</span>
<span class="k">val</span> <span class="n">formatted</span> <span class="k">=</span> <span class="n">result</span><span class="o">.</span><span class="n">map</span> <span class="o">{</span> <span class="n">r</span> <span class="k">=&gt;</span>
  <span class="k">val</span> <span class="o">(</span><span class="n">first</span><span class="o">,</span> <span class="n">last</span><span class="o">,</span> <span class="n">visits</span><span class="o">)</span> <span class="k">=</span> <span class="o">(</span><span class="n">r</span><span class="o">.</span><span class="n">name</span><span class="o">.</span><span class="n">first</span><span class="o">,</span> <span class="n">r</span><span class="o">.</span><span class="n">name</span><span class="o">.</span><span class="n">last</span><span class="o">,</span> <span class="n">r</span><span class="o">.</span><span class="n">visits</span><span class="o">)</span>
  <span class="n">s</span><span class="s">&quot;$first $last $visits&quot;</span>
<span class="o">}</span>
</code></pre></div></li>
<li><p>Use Drill to query Spark RDDs. Analysts will be able to use BI tools like MicroStrategy, Spotfire and Tableau to query in-memory data in Spark. In addition, Spark developers will be able to embed Drill execution in a Spark data pipeline, thereby enjoying the power of Drill&#39;s schema-free, columnar execution engine.</p></li>
</ul>

<h2 id="operational-enhancements">Operational Enhancements</h2>

<p>As we continue with our monthly releases and march towards the 1.0 release early next year, we&#39;re focused on improving Drill&#39;s speed and scalability. We&#39;ll also enhance Drill&#39;s multi-tenancy with more advanced workload management.</p>

<ul>
<li><strong>Speed</strong>: Drill is already extremely fast, and we&#39;re going to make it even faster over the next few months. With that said, we think that improving user productivity and time-to-insight is as important as shaving a few milliseconds off a query&#39;s runtime.</li>
<li><strong>Scalability</strong>: To date we&#39;ve focused mainly on clusters of up to a couple hundred nodes. We&#39;re currently working to support clusters with thousands of nodes. We&#39;re also improving concurrency to better support deployments in which hundreds of analysts or developers are running queries at the same time.</li>
<li><strong>Workload management</strong>: A single cluster is often shared among many users and groups, and everyone expects answers in real-time. Workload management prioritizes the allocation of resources to ensure that the most important workloads get done first so that business demands can be met. Administrators need to be able to assign priorities and quotas at a fine granularity. We&#39;re working on enhancing Drill&#39;s workload management to provide these capabilities while providing tight integration with YARN and Mesos.</li>
</ul>

<h2 id="we-would-love-to-hear-from-you!">We Would Love to Hear From You!</h2>

<p>Are there other features you would like to see in Drill? We would love to hear from you:</p>

<ul>
<li>Drill users: <a href="mailto:user@drill.apache.org">user@drill.apache.org</a></li>
<li>Drill developers: <a href="mailto:dev@drill.apache.org">dev@drill.apache.org</a></li>
<li>Me: <a href="mailto:tshiran@apache.org">tshiran@apache.org</a></li>
</ul>

<p>Happy Drilling!<br>
Tomer Shiran</p>

  </article>
 <div id="disqus_thread"></div>
    <script type="text/javascript">
        /* * * CONFIGURATION VARIABLES: EDIT BEFORE PASTING INTO YOUR WEBPAGE * * */
        var disqus_shortname = 'drill'; // required: replace example with your forum shortname

        /* * * DON'T EDIT BELOW THIS LINE * * */
        (function() {
            var dsq = document.createElement('script'); dsq.type = 'text/javascript'; dsq.async = true;
            dsq.src = '//' + disqus_shortname + '.disqus.com/embed.js';
            (document.getElementsByTagName('head')[0] || document.getElementsByTagName('body')[0]).appendChild(dsq);
        })();
    </script>
    <noscript>Please enable JavaScript to view the <a href="http://disqus.com/?ref_noscript">comments powered by Disqus.</a></noscript>
    
</div>
<script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=ra-548b2caa33765e8d" async="async"></script>

  </div>
  <p class="push"></p>
<div id="footer" class="mw">
<div class="wrapper">
Copyright © 2012-2014 The Apache Software Foundation, licensed under the Apache License, Version 2.0.<br>
Apache and the Apache feather logo are trademarks of The Apache Software Foundation. Other names appearing on the site may be trademarks of their respective owners.<br/><br/>
</div>
</div>

  <script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
})(window,document,'script','//www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-53379651-1', 'auto');
ga('send', 'pageview');
</script>

</body>
</html>
